<?php



/**
 * Anchor version 0.9.2 - install
 *
 * @author Your Name Here
 */


class i_anchor_0_9_2_install extends i_action_install
{	

	//==========================================================================
	// STEP I: INTERNAL CONFIGURABLES
	//==========================================================================
		
	public function step1_init()
	{
		$this->setStepLabel("_step_progress_settings");
		// TIP: custom inputs can be added here! see: http://www.installatron.com/sdk_commands#howinput
	}
		
	public function step1_process()
	{
		// TIP: error checking for custom inputs can be added here
	}
		
	//==========================================================================
	// STEP II: ARCHIVE EXTRACTION
	//==========================================================================
		
	public function step2_init()
	{
		$this->setStepLabel("_step_progress_extracting");
	}
		
	public function step2_process()
	{
		// extract the 'main' archive:
		$this->extract("main");
	}
		
	//==========================================================================
	// STEP III: CONFIGURING INSTALL
	//==========================================================================
		
	public function step3_init()
	{
		$this->setStepLabel("_step_progress_processing");
	}
		
	public function step3_process()
	{
		// move the contents of this directory back into the install directory and delete folder
       $this->mv('anchor-cms-0.9.2/*','.');
       $this->rm('anchor-cms-0.9.2');
	
	    // setup DB
		$dbprefix = str_replace("'", "", var_export($this->db_prefix,true));
		$this->sr("install/storage/anchor.sql", "/{{prefix}}/", $dbprefix);
		$this->sr("install/storage/anchor.sql", "/{{charset}}/", "utf8");
		$this->sr("install/storage/anchor.sql", "/{{now}}/", gmdate('Y-m-d H:i:s'));
		$this->db_import("install/storage/anchor.sql");
		
		// Add Metadata
		
		$config = array(
			'sitename' => 'My First Anchor Blog',
			'description' => 'Its not just any blog. It’s an Anchor blog.',
			'theme' => 'default'
		);

        $metatable = $dbprefix . 'meta';
		
		foreach($config as $key => $value) {
			$this->db_query("INSERT INTO `$metatable` (`key`, `value`) VALUES ('$key','$value')");
		}
		
		// Add user
		$pass = "f!sht@nk10";
		$rounds = sprintf('%02d', 10);

		// blowfish salt is 22 characters from the alphabet "./0-9A-Za-z".
		$pool = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
		$salt = substr(str_shuffle(str_repeat($pool, 5)), 0, 22);

		$hashpass = crypt($pass, '$2a$' . $rounds . '$' . $salt);

        $userstable = $dbprefix . 'users';

		$this->db_query("INSERT INTO `$userstable` (`id`, `username`, `password`, `email`, `real_name`, `bio`, `status`, `role`) VALUES (null,'admin','$hashpass','genial@gmail.com','Administrator','The bouse','active','administrator')");
		
		// Add DB config
		
		$this->mv("install/storage/database.distro.php", "anchor/config/db.php");
		$this->sr("anchor/config/db.php", "/'{{prefix}}'/", $this->var_export($this->db_prefix));
		$this->sr("anchor/config/db.php", "/{{hostname}}/", "127.0.0.1");
		$this->sr("anchor/config/db.php", "/'{{username}}'/", var_export($this->db_user,true));
		$this->sr("anchor/config/db.php", "/'{{password}}'/", var_export($this->db_pass,true));
		$this->sr("anchor/config/db.php", "/'{{database}}'/", var_export($this->db_name,true));
		$this->sr("anchor/config/db.php", "/{{port}}/", "3306");
		
		// Add app settings
		$pool = 'abcefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
		$key = substr(str_shuffle(str_repeat($pool, 3)), 0, 32);
		
		$this->mv("install/storage/application.distro.php", "anchor/config/app.php");
		$this->sr("anchor/config/app.php", "/'{{url}}'/", var_export($this->url_path,true));
		$this->sr("anchor/config/app.php", "/{{index}}/", "");
		$this->sr("anchor/config/app.php", "/{{timezone}}/", "America/New_York");
		$this->sr("anchor/config/app.php", "/{{key}}/", $key);
		$this->sr("anchor/config/app.php", "/{{language}}/", "en_GB");
		
		// Add session settings
		$sessionpath = $dbprefix . 'sessions';
		$this->mv("install/storage/session.distro.php", "anchor/config/session.php");
		$this->sr("anchor/config/session.php", "/{{table}}/", $sessionpath);
		
		// Add htaccess
		$path = str_replace("'", "", var_export($this->url_path,true));
		$this->mv("install/storage/htaccess.distro", ".htaccess");
		$this->sr(".htaccess", "/{{base}}/", $path);
		$this->sr(".htaccess", "/{{index}}/", "index.php/$1");
		
		// Remove Install Directory
		$this->rm('install');
		
	}}



?>